#ifndef _LARGEASMINT_H_
#define _LARGEASMINT_H_

#include <stdint.h>
#include <memory.h>
#include <string.h>
#include <stdio.h>

#ifndef _LARGEASMINT_LENGTH_
#define _LARGEASMINT_LENGTH_ 64
#endif

class LargeAsmInt
{
private:
	// raw data
	uint32_t data[_LARGEASMINT_LENGTH_];

	// hex char to int
	uint8_t	htoi(char val);

public:
	LargeAsmInt()
	{
		null();
	};

	~LargeAsmInt()
	{

	};

	void null()
	{
		memset(data, 0, sizeof(uint32_t) * _LARGEASMINT_LENGTH_);
	};

	// prints the number in hex format
	void print()
	{
		printf("0x");
		for (int i = _LARGEASMINT_LENGTH_-1; i >= 0; --i)
			printf(" %08x", data[i]);
	};

	LargeAsmInt& operator = (LargeAsmInt& inOther);
	LargeAsmInt& operator = (const char* inVal);

	LargeAsmInt operator+ (LargeAsmInt& inOther);
	LargeAsmInt operator+ (uint32_t inOther);

	LargeAsmInt operator- (LargeAsmInt& inOther);
	LargeAsmInt operator- (uint32_t inOther);

	LargeAsmInt operator* (LargeAsmInt& inOther);
	LargeAsmInt operator* (uint32_t inOther);

	LargeAsmInt operator/ (LargeAsmInt& inOther);
	LargeAsmInt operator/ (uint32_t inOther);

	LargeAsmInt operator% (LargeAsmInt& inOther);
	LargeAsmInt operator% (uint32_t inOther);

	LargeAsmInt operator<< (uint32_t inOther);

	LargeAsmInt operator>> (uint32_t inOther);

	LargeAsmInt operator| (LargeAsmInt& inOther);
	LargeAsmInt operator| (uint32_t inOther);

	LargeAsmInt operator& (LargeAsmInt& inOther);
	LargeAsmInt operator& (uint32_t inOther);

	LargeAsmInt operator^ (LargeAsmInt& inOther);
	LargeAsmInt operator^ (uint32_t inOther);

	LargeAsmInt& operator+= (LargeAsmInt& inOther);
	LargeAsmInt& operator+= (uint32_t inOther);
	
	LargeAsmInt& operator-= (LargeAsmInt& inOther);
	LargeAsmInt& operator-= (uint32_t inOther);

	LargeAsmInt& operator*= (LargeAsmInt& inOther);
	LargeAsmInt& operator*= (uint32_t inOther);

	LargeAsmInt& operator/= (LargeAsmInt& inOther);
	LargeAsmInt& operator/= (uint32_t inOther);

	LargeAsmInt& operator%= (LargeAsmInt& inOther);
	LargeAsmInt& operator%= (uint32_t inOther);

	LargeAsmInt& operator<<= (uint32_t inOther);

	LargeAsmInt& operator>>= (uint32_t inOther);

	LargeAsmInt& operator|= (LargeAsmInt& inOther);
	LargeAsmInt& operator|= (uint32_t inOther);

	LargeAsmInt& operator&= (LargeAsmInt& inOther);
	LargeAsmInt& operator&= (uint32_t inOther);

	LargeAsmInt& operator^= (LargeAsmInt& inOther);
	LargeAsmInt& operator^= (uint32_t inOther);

	uint32_t operator[] (uint32_t inOther);
};

typedef LargeAsmInt laInt;

#endif