

#include "LargeInt.h"
#include "LargeAsmInt.h"
#include <stdio.h>
#include <windows.h>

#define ITERATIONS 10000000
#define ITERATIONS2 100000000

int main(void)
{
	LargeAsmInt	asm1, asm2;

	asm1 = "0x53ab9803ac56c76fd43ac45364bc898b76fd43ac";
	asm2 = "0x0a5bc76fd43ac564bc87efd5453ab980998bcdea";

	DWORD start, end;
	LargeInt<128> int1, int2;

	int1 = "0x53ab9803ac56c76fd43ac45364bc898b76fd43ac";
	int2 = "0x0a5bc76fd43ac564bc87efd5453ab980998bcdea";

	start = GetTickCount();
	for (long i = 0; i < ITERATIONS; ++i)
		asm1 + asm2;
	end = GetTickCount();
	printf("Addition LargeAsmInt: %d\n", end - start);

	start = GetTickCount();
	for (long i = 0; i < ITERATIONS; ++i)
		int1 + int2;
	end = GetTickCount();
	printf("Addition LargeInt: %d\n", end - start);

	start = GetTickCount();
	for (long i = 0; i < ITERATIONS; ++i)
		asm1 += asm2;
	end = GetTickCount();
	printf("+= LargeAsmInt: %d\n", end - start);

	start = GetTickCount();
	for (long i = 0; i < ITERATIONS; ++i)
		int1 += int2;
	end = GetTickCount();
	printf("+= LargeInt: %d\n", end - start);

	/*start = GetTickCount();
	for (long i = 0; i < ITERATIONS; ++i)
		int1 - int2;
	end = GetTickCount();
	printf("Substraction LargeInt: %d\n", end - start);*/

	start = GetTickCount();
	for (long i = 0; i < ITERATIONS; ++i)
		asm1 << (i % 80);
	end = GetTickCount();
	printf("Shift << LargeAsmInt: %d\n", end - start);

	start = GetTickCount();
	for (long i = 0; i < ITERATIONS; ++i)
		int1 << (i % 80);
	end = GetTickCount();
	printf("Shift << LargeInt: %d\n", end - start);

	/*start = GetTickCount();
	for (long i = 0; i < ITERATIONS; ++i)
		asm1 * asm2;
	end = GetTickCount();
	printf("Multiplication LargeAsmInt: %d\n", end - start);

	start = GetTickCount();
	for (long i = 0; i < ITERATIONS; ++i)
		int1 * int2;
	end = GetTickCount();
	printf("Multiplication LargeInt: %d\n", end - start);

	/*start = GetTickCount();
	for (long i = 0; i < ITERATIONS; ++i)
		int1 / int2;
	end = GetTickCount();
	printf("Division LargeInt: %d\n", end - start);

	start = GetTickCount();
	for (long i = 0; i < ITERATIONS; ++i)
		int1 % int2;
	end = GetTickCount();
	printf("Modulo LargeInt: %d\n", end - start);*/

	system("pause");

	return 0;
}